



/* 
 * Gewohnter UART stuff für Ein- und Ausgabe 
 * uart_init() komplett aus [1]
 * *_putchar(), *_getchar() größtenteils aus [1] 
*/

void uart_init(void){
    UBRR0H = UBRRH_VALUE;
    UBRR0L = UBRRL_VALUE;
#if USE_2X
    UCSR0A |= _BV(U2X0);
#else
    UCSR0A &= ~(_BV(U2X0));
#endif
    
    UCSR0C = _BV(UCSZ01) | _BV(UCSZ00); /* 8-bit data */
    UCSR0B = _BV(RXEN0) | _BV(TXEN0);   /* Enable RX and TX */
}

void uart_putchar(char c, FILE *stream) {
    if (c == '\n') {
        uart_putchar('\r', stream);
    }
    loop_until_bit_is_set(UCSR0A, UDRE0); /* Wait until data register is empty */
    UDR0 = c;
}

char uart_getchar(FILE *stream) {
    loop_until_bit_is_set(UCSR0A, RXC0); /* Wait until data exists. */
    char c = UDR0;
    if(c == '\r') c = '\n';
    return c;
}

FILE uart_io = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

/* 
 * Eigene Funktion zum flushen des Streams
 */
void jflush(){
    while(getchar() != '\n') puts("Eingabe beenden mit Enter"); 
}
